Index: /trunk/sources/LibSVM/Solver.cs
===================================================================
--- /trunk/sources/LibSVM/Solver.cs	(revision 2414)
+++ /trunk/sources/LibSVM/Solver.cs	(revision 2415)
@@ -19,179 +19,16 @@
 
 using System;
+using System.Linq;
 using System.Collections.Generic;
 using System.Diagnostics;
+using System.IO;
 
 namespace SVM
 {
-    //
-    // Kernel evaluation
-    //
-    // the static method k_function is for doing single kernel evaluation
-    // the constructor of Kernel prepares to calculate the l*l kernel matrix
-    // the member function get_Q is for getting one column from the Q Matrix
-    //
-    internal abstract class QMatrix
-    {
-        public abstract float[] get_Q(int column, int len);
-        public abstract float[] get_QD();
-        public abstract void swap_index(int i, int j);
-    }
-
-    internal abstract class Kernel : QMatrix
-    {
-        private Node[][] _x;
-        private double[] _x_square;
-
-        // Parameter
-        private KernelType kernel_type;
-        private int degree;
-        private double gamma;
-        private double coef0;
-
-        public override void swap_index(int i, int j)
-        {
-            do { Node[] _ = _x[i]; _x[i] = _x[j]; _x[j] = _; } while (false);
-            if (_x_square != null) do { double _ = _x_square[i]; _x_square[i] = _x_square[j]; _x_square[j] = _; } while (false);
-        }
-
-        private static double powi(double baseValue, int times)
-        {
-            double tmp = baseValue, ret = 1.0;
-
-            for (int t = times; t > 0; t /= 2)
-            {
-                if (t % 2 == 1) ret *= tmp;
-                tmp = tmp * tmp;
-            }
-            return ret;
-        }
-
-        private static double tanh(double x)
-        {
-            double e = Math.Exp(x);
-            return 1.0 - 2.0 / (e * e + 1);
-        }
-
-        public double kernel_function(int i, int j)
-        {
-            switch (kernel_type)
-            {
-                case KernelType.LINEAR:
-                    return dot(_x[i], _x[j]);
-                case KernelType.POLY:
-                    return powi(gamma * dot(_x[i], _x[j]) + coef0, degree);
-                case KernelType.RBF:
-                    return Math.Exp(-gamma * (_x_square[i] + _x_square[j] - 2 * dot(_x[i], _x[j])));
-                case KernelType.SIGMOID:
-                    return tanh(gamma * dot(_x[i], _x[j]) + coef0);
-                case KernelType.PRECOMPUTED:
-                    return _x[i][(int)(_x[j][0].Value)].Value;
-                default:
-                    return 0;
-            }
-        }
-
-        public Kernel(int l, Node[][] x_, Parameter param)
-        {
-            this.kernel_type = param.KernelType;
-            this.degree = param.Degree;
-            this.gamma = param.Gamma;
-            this.coef0 = param.Coefficient0;
-
-            _x = (Node[][])x_.Clone();
-
-            if (kernel_type == KernelType.RBF)
-            {
-                _x_square = new double[l];
-                for (int i = 0; i < l; i++)
-                    _x_square[i] = dot(_x[i], _x[i]);
-            }
-            else _x_square = null;
-        }
-
-        public static double dot(Node[] x, Node[] y)
-        {
-            double sum = 0;
-            int xlen = x.Length;
-            int ylen = y.Length;
-            int i = 0;
-            int j = 0;
-            while (i < xlen && j < ylen)
-            {
-                if (x[i].Index == y[j].Index)
-                    sum += x[i++].Value * y[j++].Value;
-                else
-                {
-                    if (x[i].Index > y[j].Index)
-                        ++j;
-                    else
-                        ++i;
-                }
-            }
-            return sum;
-        }
-
-        public static double k_function(Node[] x, Node[] y, Parameter param)
-        {
-            switch (param.KernelType)
-            {
-                case KernelType.LINEAR:
-                    return dot(x, y);
-                case KernelType.POLY:
-                    return powi(param.Gamma * dot(x, y) + param.Coefficient0, param.Degree);
-                case KernelType.RBF:
-                    {
-                        double sum = 0;
-                        int xlen = x.Length;
-                        int ylen = y.Length;
-                        int i = 0;
-                        int j = 0;
-                        while (i < xlen && j < ylen)
-                        {
-                            if (x[i].Index == y[j].Index)
-                            {
-                                double d = x[i++].Value - y[j++].Value;
-                                sum += d * d;
-                            }
-                            else if (x[i].Index > y[j].Index)
-                            {
-                                sum += y[j].Value * y[j].Value;
-                                ++j;
-                            }
-                            else
-                            {
-                                sum += x[i].Value * x[i].Value;
-                                ++i;
-                            }
-                        }
-
-                        while (i < xlen)
-                        {
-                            sum += x[i].Value * x[i].Value;
-                            ++i;
-                        }
-
-                        while (j < ylen)
-                        {
-                            sum += y[j].Value * y[j].Value;
-                            ++j;
-                        }
-
-                        return Math.Exp(-param.Gamma * sum);
-                    }
-                case KernelType.SIGMOID:
-                    return tanh(param.Gamma * dot(x, y) + param.Coefficient0);
-                case KernelType.PRECOMPUTED:
-                    return x[(int)(y[0].Value)].Value;
-                default:
-                    return 0;
-            }
-        }
-    }
 
     // An SMO algorithm in Fan et al., JMLR 6(2005), p. 1889--1918
     // Solves:
     //
-    //	min 0.5(\alpha^T Q \alpha) + p^T \alpha
+    //	Min 0.5(\alpha^T Q \alpha) + p^T \alpha
     //
     //		y^T \alpha = \delta
@@ -211,28 +48,29 @@
     {
         protected int active_size;
-        protected short[] y;
+        protected sbyte[] y;
         protected double[] G;		// gradient of objective function
-        protected const byte LOWER_BOUND = 0;
-        protected const byte UPPER_BOUND = 1;
-        protected const byte FREE = 2;
-        protected byte[] alpha_status;	// LOWER_BOUND, UPPER_BOUND, FREE
-        protected double[] alpha;
-        protected QMatrix Q;
+        private const byte LOWER_BOUND = 0;
+        private const byte UPPER_BOUND = 1;
+        private const byte FREE = 2;
+        private byte[] alpha_status;	// LOWER_BOUND, UPPER_BOUND, FREE
+        private double[] alpha;
+        protected IQMatrix Q;
         protected float[] QD;
-        protected double eps;
-        protected double Cp, Cn;
-        protected double[] p;
-        protected int[] active_set;
-        protected double[] G_bar;		// gradient, if we treat free variables as 0
+        protected double EPS;
+        private double Cp, Cn;
+        private double[] p;
+        private int[] active_set;
+        private double[] G_bar;		// gradient, if we treat free variables as 0
         protected int l;
-        protected bool unshrinked;	// XXX
+        protected bool unshrink;	// XXX
 
         protected const double INF = double.PositiveInfinity;
 
-        protected double get_C(int i)
+        private double get_C(int i)
         {
             return (y[i] > 0) ? Cp : Cn;
         }
-        protected void update_alpha_status(int i)
+
+        private void update_alpha_status(int i)
         {
             if (alpha[i] >= get_C(i))
@@ -242,11 +80,11 @@
             else alpha_status[i] = FREE;
         }
+
         protected bool is_upper_bound(int i) { return alpha_status[i] == UPPER_BOUND; }
         protected bool is_lower_bound(int i) { return alpha_status[i] == LOWER_BOUND; }
-        protected bool is_free(int i) { return alpha_status[i] == FREE; }
-
-        // java: information about solution except alpha,
-        // because we cannot return multiple values otherwise...
-        internal class SolutionInfo
+
+        private bool is_free(int i) { return alpha_status[i] == FREE; }
+
+        public class SolutionInfo
         {
             public double obj;
@@ -259,12 +97,12 @@
         protected void swap_index(int i, int j)
         {
-            Q.swap_index(i, j);
-            do { short _ = y[i]; y[i] = y[j]; y[j] = _; } while (false);
-            do { double _ = G[i]; G[i] = G[j]; G[j] = _; } while (false);
-            do { byte _ = alpha_status[i]; alpha_status[i] = alpha_status[j]; alpha_status[j] = _; } while (false);
-            do { double _ = alpha[i]; alpha[i] = alpha[j]; alpha[j] = _; } while (false);
-            do { double _ = p[i]; p[i] = p[j]; p[j] = _; } while (false);
-            do { int _ = active_set[i]; active_set[i] = active_set[j]; active_set[j] = _; } while (false);
-            do { double _ = G_bar[i]; G_bar[i] = G_bar[j]; G_bar[j] = _; } while (false);
+            Q.SwapIndex(i, j);
+            y.SwapIndex(i, j);
+            G.SwapIndex(i, j);
+            alpha_status.SwapIndex(i, j);
+            alpha.SwapIndex(i, j);
+            p.SwapIndex(i, j);
+            active_set.SwapIndex(i, j);
+            G_bar.SwapIndex(i, j);
         }
 
@@ -275,31 +113,52 @@
             if (active_size == l) return;
 
-            int i;
-            for (i = active_size; i < l; i++)
-                G[i] = G_bar[i] + p[i];
-
-            for (i = 0; i < active_size; i++)
-                if (is_free(i))
-                {
-                    float[] Q_i = Q.get_Q(i, l);
-                    double alpha_i = alpha[i];
-                    for (int j = active_size; j < l; j++)
-                        G[j] += alpha_i * Q_i[j];
-                }
-        }
-
-        public virtual void Solve(int l, QMatrix Q, double[] p_, short[] y_,
-               double[] alpha_, double Cp, double Cn, double eps, SolutionInfo si, bool shrinking)
+            int i, j;
+            int nr_free = 0;
+
+            for (j = active_size; j < l; j++)
+                G[j] = G_bar[j] + p[j];
+
+            for (j = 0; j < active_size; j++)
+                if (is_free(j))
+                    nr_free++;
+
+            if (2 * nr_free < active_size)
+                Procedures.info("\nWarning: using -h 0 may be faster\n");
+
+            if (nr_free * l > 2 * active_size * (l - active_size))
+            {
+                for (i = active_size; i < l; i++)
+                {
+                    float[] Q_i = Q.GetQ(i, active_size);
+                    for (j = 0; j < active_size; j++)
+                        if (is_free(j))
+                            G[i] += alpha[j] * Q_i[j];
+                }
+            }
+            else
+            {
+                for (i = 0; i < active_size; i++)
+                    if (is_free(i))
+                    {
+                        float[] Q_i = Q.GetQ(i, l);
+                        double alpha_i = alpha[i];
+                        for (j = active_size; j < l; j++)
+                            G[j] += alpha_i * Q_i[j];
+                    }
+            }
+        }
+
+        public virtual void Solve(int l, IQMatrix Q, double[] p_, sbyte[] y_, double[] alpha_, double Cp, double Cn, double eps, SolutionInfo si, bool shrinking)
         {
             this.l = l;
             this.Q = Q;
-            QD = Q.get_QD();
+            QD = Q.GetQD();
             p = (double[])p_.Clone();
-            y = (short[])y_.Clone();
+            y = (sbyte[])y_.Clone();
             alpha = (double[])alpha_.Clone();
             this.Cp = Cp;
             this.Cn = Cn;
-            this.eps = eps;
-            this.unshrinked = false;
+            this.EPS = eps;
+            this.unshrink = false;
 
             // initialize alpha_status
@@ -331,5 +190,5 @@
                     if (!is_lower_bound(i))
                     {
-                        float[] Q_i = Q.get_Q(i, l);
+                        float[] Q_i = Q.GetQ(i, l);
                         double alpha_i = alpha[i];
                         int j;
@@ -356,5 +215,5 @@
                     counter = Math.Min(l, 1000);
                     if (shrinking) do_shrinking();
-                    Debug.Write(".");
+                    Procedures.info(".");
                 }
 
@@ -365,5 +224,5 @@
                     // reset active set size and check
                     active_size = l;
-                    Debug.Write("*");
+                    Procedures.info("*");
                     if (select_working_set(working_set) != 0)
                         break;
@@ -379,6 +238,6 @@
                 // update alpha[i] and alpha[j], handle bounds carefully
 
-                float[] Q_i = Q.get_Q(i, active_size);
-                float[] Q_j = Q.get_Q(j, active_size);
+                float[] Q_i = Q.GetQ(i, active_size);
+                float[] Q_j = Q.GetQ(j, active_size);
 
                 double C_i = get_C(i);
@@ -495,5 +354,5 @@
                     if (ui != is_upper_bound(i))
                     {
-                        Q_i = Q.get_Q(i, l);
+                        Q_i = Q.GetQ(i, l);
                         if (ui)
                             for (k = 0; k < l; k++)
@@ -506,5 +365,5 @@
                     if (uj != is_upper_bound(j))
                     {
-                        Q_j = Q.get_Q(j, l);
+                        Q_j = Q.GetQ(j, l);
                         if (uj)
                             for (k = 0; k < l; k++)
@@ -541,21 +400,21 @@
             si.upper_bound_n = Cn;
 
-            Debug.Write("\noptimization finished, #iter = " + iter + "\n");
+            Procedures.info("\noptimization finished, #iter = " + iter + "\n");
         }
 
         // return 1 if already optimal, return 0 otherwise
-        protected virtual int select_working_set(int[] working_set)
+        int select_working_set(int[] working_set)
         {
             // return i,j such that
-            // i: maximizes -y_i * grad(f)_i, i in I_up(\alpha)
+            // i: Maximizes -y_i * grad(f)_i, i in I_up(\alpha)
             // j: mimimizes the decrease of obj value
             //    (if quadratic coefficeint <= 0, replace it with tau)
             //    -y_j*grad(f)_j < -y_i*grad(f)_i, j in I_low(\alpha)
 
-            double Gmax = -INF;
-            double Gmax2 = -INF;
-            int Gmax_idx = -1;
-            int Gmin_idx = -1;
-            double obj_diff_min = INF;
+            double GMax = -INF;
+            double GMax2 = -INF;
+            int GMax_idx = -1;
+            int GMin_idx = -1;
+            double obj_diff_Min = INF;
 
             for (int t = 0; t < active_size; t++)
@@ -563,8 +422,8 @@
                 {
                     if (!is_upper_bound(t))
-                        if (-G[t] >= Gmax)
-                        {
-                            Gmax = -G[t];
-                            Gmax_idx = t;
+                        if (-G[t] >= GMax)
+                        {
+                            GMax = -G[t];
+                            GMax_idx = t;
                         }
                 }
@@ -572,15 +431,15 @@
                 {
                     if (!is_lower_bound(t))
-                        if (G[t] >= Gmax)
-                        {
-                            Gmax = G[t];
-                            Gmax_idx = t;
-                        }
-                }
-
-            int i = Gmax_idx;
+                        if (G[t] >= GMax)
+                        {
+                            GMax = G[t];
+                            GMax_idx = t;
+                        }
+                }
+
+            int i = GMax_idx;
             float[] Q_i = null;
-            if (i != -1) // null Q_i not accessed: Gmax=-INF if i=-1
-                Q_i = Q.get_Q(i, active_size);
+            if (i != -1) // null Q_i not accessed: GMax=-INF if i=-1
+                Q_i = Q.GetQ(i, active_size);
 
             for (int j = 0; j < active_size; j++)
@@ -590,11 +449,11 @@
                     if (!is_lower_bound(j))
                     {
-                        double grad_diff = Gmax + G[j];
-                        if (G[j] >= Gmax2)
-                            Gmax2 = G[j];
+                        double grad_diff = GMax + G[j];
+                        if (G[j] >= GMax2)
+                            GMax2 = G[j];
                         if (grad_diff > 0)
                         {
                             double obj_diff;
-                            double quad_coef = Q_i[i] + QD[j] - 2 * y[i] * Q_i[j];
+                            double quad_coef = Q_i[i] + QD[j] - 2.0 * y[i] * Q_i[j];
                             if (quad_coef > 0)
                                 obj_diff = -(grad_diff * grad_diff) / quad_coef;
@@ -602,8 +461,8 @@
                                 obj_diff = -(grad_diff * grad_diff) / 1e-12;
 
-                            if (obj_diff <= obj_diff_min)
+                            if (obj_diff <= obj_diff_Min)
                             {
-                                Gmin_idx = j;
-                                obj_diff_min = obj_diff;
+                                GMin_idx = j;
+                                obj_diff_Min = obj_diff;
                             }
                         }
@@ -614,11 +473,11 @@
                     if (!is_upper_bound(j))
                     {
-                        double grad_diff = Gmax - G[j];
-                        if (-G[j] >= Gmax2)
-                            Gmax2 = -G[j];
+                        double grad_diff = GMax - G[j];
+                        if (-G[j] >= GMax2)
+                            GMax2 = -G[j];
                         if (grad_diff > 0)
                         {
                             double obj_diff;
-                            double quad_coef = Q_i[i] + QD[j] + 2 * y[i] * Q_i[j];
+                            double quad_coef = Q_i[i] + QD[j] + 2.0 * y[i] * Q_i[j];
                             if (quad_coef > 0)
                                 obj_diff = -(grad_diff * grad_diff) / quad_coef;
@@ -626,8 +485,8 @@
                                 obj_diff = -(grad_diff * grad_diff) / 1e-12;
 
-                            if (obj_diff <= obj_diff_min)
+                            if (obj_diff <= obj_diff_Min)
                             {
-                                Gmin_idx = j;
-                                obj_diff_min = obj_diff;
+                                GMin_idx = j;
+                                obj_diff_Min = obj_diff;
                             }
                         }
@@ -636,27 +495,27 @@
             }
 
-            if (Gmax + Gmax2 < eps)
+            if (GMax + GMax2 < EPS)
                 return 1;
 
-            working_set[0] = Gmax_idx;
-            working_set[1] = Gmin_idx;
+            working_set[0] = GMax_idx;
+            working_set[1] = GMin_idx;
             return 0;
         }
 
-        private bool be_shrunken(int i, double Gmax1, double Gmax2)
+        private bool be_shrunk(int i, double GMax1, double GMax2)
         {
             if (is_upper_bound(i))
             {
                 if (y[i] == +1)
-                    return (-G[i] > Gmax1);
+                    return (-G[i] > GMax1);
                 else
-                    return (-G[i] > Gmax2);
+                    return (-G[i] > GMax2);
             }
             else if (is_lower_bound(i))
             {
                 if (y[i] == +1)
-                    return (G[i] > Gmax2);
+                    return (G[i] > GMax2);
                 else
-                    return (G[i] > Gmax1);
+                    return (G[i] > GMax1);
             }
             else
@@ -664,11 +523,11 @@
         }
 
-        protected virtual void do_shrinking()
+        void do_shrinking()
         {
             int i;
-            double Gmax1 = -INF;		// max { -y_i * grad(f)_i | i in I_up(\alpha) }
-            double Gmax2 = -INF;		// max { y_i * grad(f)_i | i in I_low(\alpha) }
-
-            // find maximal violating pair first
+            double GMax1 = -INF;		// Max { -y_i * grad(f)_i | i in I_up(\alpha) }
+            double GMax2 = -INF;		// Max { y_i * grad(f)_i | i in I_low(\alpha) }
+
+            // find Maximal violating pair first
             for (i = 0; i < active_size; i++)
             {
@@ -677,11 +536,11 @@
                     if (!is_upper_bound(i))
                     {
-                        if (-G[i] >= Gmax1)
-                            Gmax1 = -G[i];
+                        if (-G[i] >= GMax1)
+                            GMax1 = -G[i];
                     }
                     if (!is_lower_bound(i))
                     {
-                        if (G[i] >= Gmax2)
-                            Gmax2 = G[i];
+                        if (G[i] >= GMax2)
+                            GMax2 = G[i];
                     }
                 }
@@ -690,24 +549,29 @@
                     if (!is_upper_bound(i))
                     {
-                        if (-G[i] >= Gmax2)
-                            Gmax2 = -G[i];
+                        if (-G[i] >= GMax2)
+                            GMax2 = -G[i];
                     }
                     if (!is_lower_bound(i))
                     {
-                        if (G[i] >= Gmax1)
-                            Gmax1 = G[i];
-                    }
-                }
-            }
-
-            // shrink
+                        if (G[i] >= GMax1)
+                            GMax1 = G[i];
+                    }
+                }
+            }
+
+            if (unshrink == false && GMax1 + GMax2 <= EPS * 10)
+            {
+                unshrink = true;
+                reconstruct_gradient();
+                active_size = l;
+            }
 
             for (i = 0; i < active_size; i++)
-                if (be_shrunken(i, Gmax1, Gmax2))
+                if (be_shrunk(i, GMax1, GMax2))
                 {
                     active_size--;
                     while (active_size > i)
                     {
-                        if (!be_shrunken(active_size, Gmax1, Gmax2))
+                        if (!be_shrunk(active_size, GMax1, GMax2))
                         {
                             swap_index(i, active_size);
@@ -717,29 +581,7 @@
                     }
                 }
-
-            // unshrink, check all variables again before sealed iterations
-
-            if (unshrinked || Gmax1 + Gmax2 > eps * 10) return;
-
-            unshrinked = true;
-            reconstruct_gradient();
-
-            for (i = l - 1; i >= active_size; i--)
-                if (!be_shrunken(i, Gmax1, Gmax2))
-                {
-                    while (active_size < i)
-                    {
-                        if (be_shrunken(active_size, Gmax1, Gmax2))
-                        {
-                            swap_index(i, active_size);
-                            break;
-                        }
-                        active_size++;
-                    }
-                    active_size++;
-                }
-        }
-
-        protected virtual double calculate_rho()
+        }
+
+        double calculate_rho()
         {
             double r;
@@ -786,9 +628,9 @@
     // additional constraint: e^T \alpha = constant
     //
-    sealed class Solver_NU : Solver
+    class Solver_NU : Solver
     {
         private SolutionInfo si;
 
-        public override void Solve(int l, QMatrix Q, double[] p, short[] y,
+        public sealed override void Solve(int l, IQMatrix Q, double[] p, sbyte[] y,
                double[] alpha, double Cp, double Cn, double eps,
                SolutionInfo si, bool shrinking)
@@ -799,22 +641,22 @@
 
         // return 1 if already optimal, return 0 otherwise
-        protected override int select_working_set(int[] working_set)
+        private int select_working_set(int[] working_set)
         {
             // return i,j such that y_i = y_j and
-            // i: maximizes -y_i * grad(f)_i, i in I_up(\alpha)
-            // j: minimizes the decrease of obj value
+            // i: Maximizes -y_i * grad(f)_i, i in I_up(\alpha)
+            // j: Minimizes the decrease of obj value
             //    (if quadratic coefficeint <= 0, replace it with tau)
             //    -y_j*grad(f)_j < -y_i*grad(f)_i, j in I_low(\alpha)
 
-            double Gmaxp = -INF;
-            double Gmaxp2 = -INF;
-            int Gmaxp_idx = -1;
-
-            double Gmaxn = -INF;
-            double Gmaxn2 = -INF;
-            int Gmaxn_idx = -1;
-
-            int Gmin_idx = -1;
-            double obj_diff_min = INF;
+            double GMaxp = -INF;
+            double GMaxp2 = -INF;
+            int GMaxp_idx = -1;
+
+            double GMaxn = -INF;
+            double GMaxn2 = -INF;
+            int GMaxn_idx = -1;
+
+            int GMin_idx = -1;
+            double obj_diff_Min = INF;
 
             for (int t = 0; t < active_size; t++)
@@ -822,8 +664,8 @@
                 {
                     if (!is_upper_bound(t))
-                        if (-G[t] >= Gmaxp)
-                        {
-                            Gmaxp = -G[t];
-                            Gmaxp_idx = t;
+                        if (-G[t] >= GMaxp)
+                        {
+                            GMaxp = -G[t];
+                            GMaxp_idx = t;
                         }
                 }
@@ -831,19 +673,19 @@
                 {
                     if (!is_lower_bound(t))
-                        if (G[t] >= Gmaxn)
-                        {
-                            Gmaxn = G[t];
-                            Gmaxn_idx = t;
-                        }
-                }
-
-            int ip = Gmaxp_idx;
-            int iN = Gmaxn_idx;
+                        if (G[t] >= GMaxn)
+                        {
+                            GMaxn = G[t];
+                            GMaxn_idx = t;
+                        }
+                }
+
+            int ip = GMaxp_idx;
+            int iN = GMaxn_idx;
             float[] Q_ip = null;
             float[] Q_in = null;
-            if (ip != -1) // null Q_ip not accessed: Gmaxp=-INF if ip=-1
-                Q_ip = Q.get_Q(ip, active_size);
+            if (ip != -1) // null Q_ip not accessed: GMaxp=-INF if ip=-1
+                Q_ip = Q.GetQ(ip, active_size);
             if (iN != -1)
-                Q_in = Q.get_Q(iN, active_size);
+                Q_in = Q.GetQ(iN, active_size);
 
             for (int j = 0; j < active_size; j++)
@@ -853,7 +695,7 @@
                     if (!is_lower_bound(j))
                     {
-                        double grad_diff = Gmaxp + G[j];
-                        if (G[j] >= Gmaxp2)
-                            Gmaxp2 = G[j];
+                        double grad_diff = GMaxp + G[j];
+                        if (G[j] >= GMaxp2)
+                            GMaxp2 = G[j];
                         if (grad_diff > 0)
                         {
@@ -865,8 +707,8 @@
                                 obj_diff = -(grad_diff * grad_diff) / 1e-12;
 
-                            if (obj_diff <= obj_diff_min)
+                            if (obj_diff <= obj_diff_Min)
                             {
-                                Gmin_idx = j;
-                                obj_diff_min = obj_diff;
+                                GMin_idx = j;
+                                obj_diff_Min = obj_diff;
                             }
                         }
@@ -877,7 +719,7 @@
                     if (!is_upper_bound(j))
                     {
-                        double grad_diff = Gmaxn - G[j];
-                        if (-G[j] >= Gmaxn2)
-                            Gmaxn2 = -G[j];
+                        double grad_diff = GMaxn - G[j];
+                        if (-G[j] >= GMaxn2)
+                            GMaxn2 = -G[j];
                         if (grad_diff > 0)
                         {
@@ -889,8 +731,8 @@
                                 obj_diff = -(grad_diff * grad_diff) / 1e-12;
 
-                            if (obj_diff <= obj_diff_min)
+                            if (obj_diff <= obj_diff_Min)
                             {
-                                Gmin_idx = j;
-                                obj_diff_min = obj_diff;
+                                GMin_idx = j;
+                                obj_diff_Min = obj_diff;
                             }
                         }
@@ -899,31 +741,31 @@
             }
 
-            if (Math.Max(Gmaxp + Gmaxp2, Gmaxn + Gmaxn2) < eps)
+            if (Math.Max(GMaxp + GMaxp2, GMaxn + GMaxn2) < EPS)
                 return 1;
 
-            if (y[Gmin_idx] == +1)
-                working_set[0] = Gmaxp_idx;
+            if (y[GMin_idx] == +1)
+                working_set[0] = GMaxp_idx;
             else
-                working_set[0] = Gmaxn_idx;
-            working_set[1] = Gmin_idx;
+                working_set[0] = GMaxn_idx;
+            working_set[1] = GMin_idx;
 
             return 0;
         }
 
-        private bool be_shrunken(int i, double Gmax1, double Gmax2, double Gmax3, double Gmax4)
+        private bool be_shrunk(int i, double GMax1, double GMax2, double GMax3, double GMax4)
         {
             if (is_upper_bound(i))
             {
                 if (y[i] == +1)
-                    return (-G[i] > Gmax1);
+                    return (-G[i] > GMax1);
                 else
-                    return (-G[i] > Gmax4);
+                    return (-G[i] > GMax4);
             }
             else if (is_lower_bound(i))
             {
                 if (y[i] == +1)
-                    return (G[i] > Gmax2);
+                    return (G[i] > GMax2);
                 else
-                    return (G[i] > Gmax3);
+                    return (G[i] > GMax3);
             }
             else
@@ -931,12 +773,12 @@
         }
 
-        protected override void do_shrinking()
-        {
-            double Gmax1 = -INF;	// max { -y_i * grad(f)_i | y_i = +1, i in I_up(\alpha) }
-            double Gmax2 = -INF;	// max { y_i * grad(f)_i | y_i = +1, i in I_low(\alpha) }
-            double Gmax3 = -INF;	// max { -y_i * grad(f)_i | y_i = -1, i in I_up(\alpha) }
-            double Gmax4 = -INF;	// max { y_i * grad(f)_i | y_i = -1, i in I_low(\alpha) }
-
-            // find maximal violating pair first
+        private void do_shrinking()
+        {
+            double GMax1 = -INF;	// Max { -y_i * grad(f)_i | y_i = +1, i in I_up(\alpha) }
+            double GMax2 = -INF;	// Max { y_i * grad(f)_i | y_i = +1, i in I_low(\alpha) }
+            double GMax3 = -INF;	// Max { -y_i * grad(f)_i | y_i = -1, i in I_up(\alpha) }
+            double GMax4 = -INF;	// Max { y_i * grad(f)_i | y_i = -1, i in I_low(\alpha) }
+
+            // find Maximal violating pair first
             int i;
             for (i = 0; i < active_size; i++)
@@ -946,7 +788,7 @@
                     if (y[i] == +1)
                     {
-                        if (-G[i] > Gmax1) Gmax1 = -G[i];
-                    }
-                    else if (-G[i] > Gmax4) Gmax4 = -G[i];
+                        if (-G[i] > GMax1) GMax1 = -G[i];
+                    }
+                    else if (-G[i] > GMax4) GMax4 = -G[i];
                 }
                 if (!is_lower_bound(i))
